diff --git a/testsuite/hmac-test.c b/testsuite/hmac-test.c
index 0f14934..0356cf5 100644
--- a/testsuite/hmac-test.c
+++ b/testsuite/hmac-test.c
@@ -782,122 +868,122 @@ test_main(void)
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
-	       "aaaaaa"),
-	    LDATA("This is a test using a larger than block-size ke"
+	       "aaaaaa",
+	    "This is a test using a larger than block-size ke"
 		  "y and a larger than block-size data. The key nee"
 		  "ds to be hashed before being used by the HMAC al"
-		  "gorithm."),
-	    H("e37b6a775dc87dbaa4dfa9f96e5e3ffd"
+		  "gorithm.",
+	    "e37b6a775dc87dbaa4dfa9f96e5e3ffd"
 	      "debd71f8867289865df5a32d20cdc944"
 	      "b6022cac3c4982b10d5eeb55c3e4de15"
-	      "134676fb6de0446065c97440fa8c6a58"));
+	      "134676fb6de0446065c97440fa8c6a58");
 
   /* Additional test vectors, from Daniel Kahn Gillmor */
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA(""),
-	    H("34316413c2d6940572d0bbbf099d529d"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "",
+	    "34316413c2d6940572d0bbbf099d529d"
 	      "148b424533cf562bc1b365f530e21a31"
 	      "799fc51cef78060cc6f448a8e5d780c2"
-	      "6cdf20d4c3e6f27fe5ef576bbd05e855"));
+	      "6cdf20d4c3e6f27fe5ef576bbd05e855");
   
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("a"),
-	    H("cf1948507378bc3ab58cb6ec87f4d456"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "a",
+	    "cf1948507378bc3ab58cb6ec87f4d456"
 	      "b90d3298395c29873f1ded1e111b50fe"
 	      "c336ed24684bf19716efc309212f37aa"
-	      "715cfb9ecccf3af13691ded167b4b336"));
+	      "715cfb9ecccf3af13691ded167b4b336");
   
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("38"),
-	    H("b8201784216ce01b83cdd282616c6e89"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "38",
+	    "b8201784216ce01b83cdd282616c6e89"
 	      "644c6dfd1269ed8580bbc39b92add364"
 	      "c2b2a2018cffb1915e8625e473b67d0f"
-	      "e54a50e475dfa0e2b1a97bac1383792c"));
+	      "e54a50e475dfa0e2b1a97bac1383792c");
   
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("abc"),
-	    H("f097ee08b8c44e847a384f9fd645e35e"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "abc",
+	    "f097ee08b8c44e847a384f9fd645e35e"
 	      "4816baa9791ba39d3dc611210500b044"
 	      "873ee296bf1047dc06daa201a5767192"
-	      "5b73b4ea59c60114881c8287d0699c83"));
+	      "5b73b4ea59c60114881c8287d0699c83");
   
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("message digest"),
-	    H("921a441a884b83c76a8526da8e60d60d"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "message digest",
+	    "921a441a884b83c76a8526da8e60d60d"
 	      "17ded4eee5c29375e0d93717669a4c3e"
 	      "eba7473e95f7c1a2a85afc24a0adbc4d"
-	      "6c2bdd6ca6cab8b18d19f82d4a6c51bc"));
+	      "6c2bdd6ca6cab8b18d19f82d4a6c51bc");
   
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("640054c96f35815095617d0a8c956066"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "abcdefghijklmnopqrstuvwxyz",
+	    "640054c96f35815095617d0a8c956066"
 	      "1a6ff46bfb39110333b2c52c8866abfb"
 	      "59d9152c9b0948c1ed65c3fd72a8fb82"
-	      "190acc8830770afe5b0c5b6414c75a77"));
+	      "190acc8830770afe5b0c5b6414c75a77");
 
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"),
-	    H("835a4f5b3750b4c1fccfa88da2f746a4"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
+	    "835a4f5b3750b4c1fccfa88da2f746a4"
 	      "900160c9f18964309bb736c13b59491b"
 	      "8e32d37b724cc5aebb0f554c6338a3b5"
-	      "94c4ba26862b2dadb59b7ede1d08d53e"));
+	      "94c4ba26862b2dadb59b7ede1d08d53e");
 
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("monkey monkey monkey monkey"),
-	    LDATA("12345678901234567890123456789012345678901234567890123456789012345678901234567890"),
-	    H("fdf83dc879e3476c8e8aceff2bf6fece"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "monkey monkey monkey monkey",
+	    "12345678901234567890123456789012345678901234567890123456789012345678901234567890",
+	    "fdf83dc879e3476c8e8aceff2bf6fece"
 	      "2e4f39c7e1a167845465bb549dfa5ffe"
 	      "997e6c7cf3720eae51ed2b00ad2a8225"
-	      "375092290edfa9d48ec7e4bc8e276088"));
+	      "375092290edfa9d48ec7e4bc8e276088");
 
   /* Additional test vectors, from
      draft-kelly-ipsec-ciph-sha2-01.txt */
 
   /* Test case AUTH512-1: */
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    HL("0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_KEY,
+	    "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b"
 	       "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b"
 	       "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b"
-	       "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b"),
-	    LDATA("Hi There"),
-	    H("637edc6e01dce7e6742a99451aae82df"
+	       "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b",
+	    "Hi There",
+	    "637edc6e01dce7e6742a99451aae82df"
 	      "23da3e92439e590e43e761b33e910fb8"
 	      "ac2878ebd5803f6f0b61dbce5e251ff8"
-	      "789a4722c1be65aea45fd464e89f8f5b"));
+	      "789a4722c1be65aea45fd464e89f8f5b");
 
   /* Test case AUTH512-2: */
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    LDATA("JefeJefeJefeJefe"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, HEX_NONE,
+	    "JefeJefeJefeJefe"
 		  "JefeJefeJefeJefe"
 		  "JefeJefeJefeJefe"
-		  "JefeJefeJefeJefe"),	    
-	    LDATA("what do ya want for nothing?"),
-	    H("cb370917ae8a7ce28cfd1d8f4705d614"
+		  "JefeJefeJefeJefe",
+	    "what do ya want for nothing?",
+	    "cb370917ae8a7ce28cfd1d8f4705d614"
 	      "1c173b2a9362c15df235dfb251b15454"
 	      "6aa334ae9fb9afc2184932d8695e397b"
-	      "fa0ffb93466cfcceaae38c833b7dba38"));
+	      "fa0ffb93466cfcceaae38c833b7dba38");
 
   /* Test case AUTH512-3: */
-  HMAC_TEST(sha512, SHA512_DIGEST_SIZE,
-	    HL("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
+  hmac_test(alg_sha512, SHA512_DIGEST_SIZE, (HEX_KEY|HEX_MSG),
+	    "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
 	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
-	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"),
-	    HL("dddddddddddddddddddddddddddddddd"
+	       "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
+	    "dddddddddddddddddddddddddddddddd"
 	       "dddddddddddddddddddddddddddddddd"
 	       "dddddddddddddddddddddddddddddddd"
-	       "dddd"),
-	    H("2ee7acd783624ca9398710f3ee05ae41"
+	       "dddd",
+	    "2ee7acd783624ca9398710f3ee05ae41"
 	      "b9f9b0510c87e49e586cc9bf961733d8"
 	      "623c7b55cebefccf02d5581acc1c9d5f"
-	      "b1ff68a1de45509fbe4da9a433922655"));
+	      "b1ff68a1de45509fbe4da9a433922655");
 
   /* Test case AUTH512-3 from same document seems broken. */
   
diff --git a/testsuite/md2-test.c b/testsuite/md2-test.c
index 8ab45c1..3d4a064 100644
--- a/testsuite/md2-test.c
+++ b/testsuite/md2-test.c
@@ -5,23 +5,23 @@ int
 test_main(void)
 {
   /* Testcases from RFC 1319 */
-  test_hash(&nettle_md2, 0, "",
-	    H("8350e5a3e24c153df2275c9f80692773"));
-  test_hash(&nettle_md2, LDATA("a"),
-	    H("32ec01ec4a6dac72c0ab96fb34c0b5d1"));
-  test_hash(&nettle_md2, LDATA("abc"),
-	    H("da853b0d3f88d99b30283a69e6ded6bb"));
-  test_hash(&nettle_md2, LDATA("message digest"),
-	    H("ab4f496bfb2a530b219ff33031fe06b0"));
-  test_hash(&nettle_md2, LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("4e8ddff3650292ab5a4108c3aa47940b"));
+  test_hash(&nettle_md2, "",
+	    "8350e5a3e24c153df2275c9f80692773");
+  test_hash(&nettle_md2, "a",
+	    "32ec01ec4a6dac72c0ab96fb34c0b5d1");
+  test_hash(&nettle_md2, "abc",
+	    "da853b0d3f88d99b30283a69e6ded6bb");
+  test_hash(&nettle_md2, "message digest",
+	    "ab4f496bfb2a530b219ff33031fe06b0");
+  test_hash(&nettle_md2, "abcdefghijklmnopqrstuvwxyz",
+	    "4e8ddff3650292ab5a4108c3aa47940b");
   test_hash(&nettle_md2,
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
-		  "0123456789"),
-	    H("da33def2a42df13975352846c30338cd"));
-  test_hash(&nettle_md2, LDATA("1234567890123456789012345678901234567890"
-			       "1234567890123456789012345678901234567890"),
-	    H("d5976f79d83d3a0dc9806c3c66f3efd8"));
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
+		  "0123456789",
+	    "da33def2a42df13975352846c30338cd");
+  test_hash(&nettle_md2, "1234567890123456789012345678901234567890"
+			       "1234567890123456789012345678901234567890",
+	    "d5976f79d83d3a0dc9806c3c66f3efd8");
 
   SUCCESS();
 }
diff --git a/testsuite/md4-test.c b/testsuite/md4-test.c
index 208456d..188c9d1 100644
--- a/testsuite/md4-test.c
+++ b/testsuite/md4-test.c
@@ -4,35 +4,36 @@
 int
 test_main(void)
 {
+// #define x) (sizeof(x) - 1), x
   /* Testcases from RFC 1320 */
-  test_hash(&nettle_md4, LDATA(""),
-	    H("31d6cfe0d16ae931b73c59d7e0c089c0"));
-  test_hash(&nettle_md4, LDATA("a"),
-	    H("bde52cb31de33e46245e05fbdbd6fb24"));
-  test_hash(&nettle_md4, LDATA("abc"),
-	    H("a448017aaf21d8525fc10ae87aa6729d"));
-  test_hash(&nettle_md4, LDATA("message digest"),
-	    H("d9130a8164549fe818874806e1c7014b"));
-  test_hash(&nettle_md4, LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("d79e1c308aa5bbcdeea8ed63df412da9"));
+  test_hash(&nettle_md4, "",
+	    "31d6cfe0d16ae931b73c59d7e0c089c0");
+  test_hash(&nettle_md4, "a",
+	    "bde52cb31de33e46245e05fbdbd6fb24");
+  test_hash(&nettle_md4, "abc",
+	    "a448017aaf21d8525fc10ae87aa6729d");
+  test_hash(&nettle_md4, "message digest",
+	    "d9130a8164549fe818874806e1c7014b");
+  test_hash(&nettle_md4, "abcdefghijklmnopqrstuvwxyz",
+	    "d79e1c308aa5bbcdeea8ed63df412da9");
   test_hash(&nettle_md4,
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
-		  "0123456789"),
-	    H("043f8582f241db351ce627e153e7f0e4"));
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
+		  "0123456789",
+	    "043f8582f241db351ce627e153e7f0e4");
   test_hash(&nettle_md4,
-	    LDATA("12345678901234567890123456789012345678901234567890"
-		  "123456789012345678901234567890"),
-	    H("e33b4ddc9c38f2199c3e7b164fcc0536"));
+	    "12345678901234567890123456789012345678901234567890"
+		  "123456789012345678901234567890",
+	    "e33b4ddc9c38f2199c3e7b164fcc0536");
 
   /* Additional test vectors, from Daniel Kahn Gillmor */
-  test_hash(&nettle_md4, LDATA("38"),
-	    H("ae9c7ebfb68ea795483d270f5934b71d"));
-  test_hash(&nettle_md4, LDATA("abc"),
-	    H("a448017aaf21d8525fc10ae87aa6729d"));
-  test_hash(&nettle_md4, LDATA("message digest"),
-	    H("d9130a8164549fe818874806e1c7014b"));
-  test_hash(&nettle_md4, LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("d79e1c308aa5bbcdeea8ed63df412da9"));
+  test_hash(&nettle_md4, "38",
+	    "ae9c7ebfb68ea795483d270f5934b71d");
+  test_hash(&nettle_md4, "abc",
+	    "a448017aaf21d8525fc10ae87aa6729d");
+  test_hash(&nettle_md4, "message digest",
+	    "d9130a8164549fe818874806e1c7014b");
+  test_hash(&nettle_md4, "abcdefghijklmnopqrstuvwxyz",
+	    "d79e1c308aa5bbcdeea8ed63df412da9");
 
   SUCCESS();
 }
diff --git a/testsuite/md5-compat-test.c b/testsuite/md5-compat-test.c
index bffb623..0b5e6d1 100644
--- a/testsuite/md5-compat-test.c
+++ b/testsuite/md5-compat-test.c
@@ -1,60 +1,53 @@
 #include "testutils.h"
 #include "md5-compat.h"
 
-int
-test_main(void)
+static void
+test_md5_compat(const uint8_t *data, const uint8_t *result_hex)
 {
+  const uint8_t *result = decode_hex_dup(result_hex);
+
   MD5_CTX ctx;
   unsigned char digest[MD5_DIGEST_SIZE];
 
   MD5Init(&ctx);
-  MD5Final(digest, &ctx);
-  if (!MEMEQ(MD5_DIGEST_SIZE, digest, H("D41D8CD98F00B204 E9800998ECF8427E")))
-    FAIL();
-
-  MD5Init(&ctx);
-  MD5Update(&ctx, "a", 1);
+  MD5Update(&ctx, data, strlen(data));
   MD5Final(digest, &ctx);
 
-  if (!MEMEQ(MD5_DIGEST_SIZE, digest, H("0CC175B9C0F1B6A8 31C399E269772661")))
+  if (!MEMEQ(MD5_DIGEST_SIZE, digest, result))
     FAIL();
 
-  MD5Init(&ctx);
-  MD5Update(&ctx, "abc", 3);
-  MD5Final(digest, &ctx);
-
-  if (!MEMEQ(MD5_DIGEST_SIZE, digest, H("900150983cd24fb0 D6963F7D28E17F72")))
-    FAIL();
+  free((void *)result);
+}
 
-  MD5Init(&ctx);
-  MD5Update(&ctx, "message digest", 14);
-  MD5Final(digest, &ctx);
+int test_main(void)
+{
+  test_md5_compat("",
+	    "D41D8CD98F00B204 E9800998ECF8427E");
 
-  if (!MEMEQ(MD5_DIGEST_SIZE, digest, H("F96B697D7CB7938D 525A2F31AAF161D0")))
-    FAIL();
+  test_md5_compat("a",
+	    "0CC175B9C0F1B6A8 31C399E269772661");
 
-  MD5Init(&ctx);
-  MD5Update(&ctx, "abcdefghijklmnopqrstuvwxyz", 26);
-  MD5Final(digest, &ctx);
+  test_md5_compat("abc",
+	    "900150983cd24fb0 D6963F7D28E17F72");
 
-  if (!MEMEQ(MD5_DIGEST_SIZE, digest, H("C3FCD3D76192E400 7DFB496CCA67E13B")))
-    FAIL();
+  test_md5_compat("message digest",
+	    "F96B697D7CB7938D 525A2F31AAF161D0");
 
-  MD5Init(&ctx);
-  MD5Update(&ctx, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789", 62);
-  MD5Final(digest, &ctx);
+  test_md5_compat("abcdefghijklmnopqrstuvwxyz",
+	    "C3FCD3D76192E400 7DFB496CCA67E13B");
 
-  if (!MEMEQ(MD5_DIGEST_SIZE, digest, H("D174AB98D277D9F5 A5611C2C9F419D9F")))
-    FAIL();
+  test_md5_compat("ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+	    "abcdefghijklmnopqrstuvwxyz"
+	    "0123456789",
+	    "D174AB98D277D9F5 A5611C2C9F419D9F");
 
-  MD5Init(&ctx);
-  MD5Update(&ctx, "1234567890123456789012345678901234567890"
+  test_md5_compat("1234567890123456789012345678901234567890"
 	    "1234567890123456789012345678901234567890",
-	    80);
-  MD5Final(digest, &ctx);
+	    "57EDF4A22BE3C955 AC49DA2E2107B67A");
 
-  if (!MEMEQ(MD5_DIGEST_SIZE, digest, H("57EDF4A22BE3C955 AC49DA2E2107B67A")))
-    FAIL();
+  /* Additional test vector, from Daniel Kahn Gillmor */
+  test_md5_compat("38",
+	    "a5771bce93e200c3 6f7cd9dfd0e5deaa");
 
   SUCCESS();
 }
diff --git a/testsuite/md5-test.c b/testsuite/md5-test.c
index 995f304..51ad024 100644
--- a/testsuite/md5-test.c
+++ b/testsuite/md5-test.c
@@ -4,35 +4,35 @@
 int
 test_main(void)
 {
-  test_hash(&nettle_md5, 0, "",
-	    H("D41D8CD98F00B204 E9800998ECF8427E"));
+  test_hash(&nettle_md5, "",
+	    "D41D8CD98F00B204 E9800998ECF8427E");
 
-  test_hash(&nettle_md5, 1, "a",
-	    H("0CC175B9C0F1B6A8 31C399E269772661"));
+  test_hash(&nettle_md5, "a",
+	    "0CC175B9C0F1B6A8 31C399E269772661");
 	    
-  test_hash(&nettle_md5, 3, "abc",
-	    H("900150983cd24fb0 D6963F7D28E17F72"));
+  test_hash(&nettle_md5, "abc",
+	    "900150983cd24fb0 D6963F7D28E17F72");
 
-  test_hash(&nettle_md5, 14, "message digest",
-	    H("F96B697D7CB7938D 525A2F31AAF161D0"));
+  test_hash(&nettle_md5, "message digest",
+	    "F96B697D7CB7938D 525A2F31AAF161D0");
   
-  test_hash(&nettle_md5, 26, "abcdefghijklmnopqrstuvwxyz",
-	    H("C3FCD3D76192E400 7DFB496CCA67E13B"));
+  test_hash(&nettle_md5, "abcdefghijklmnopqrstuvwxyz",
+	    "C3FCD3D76192E400 7DFB496CCA67E13B");
   
-  test_hash(&nettle_md5, 62,
+  test_hash(&nettle_md5,
 	    "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
 	    "abcdefghijklmnopqrstuvwxyz"
 	    "0123456789",
-	    H("D174AB98D277D9F5 A5611C2C9F419D9F"));
+	    "D174AB98D277D9F5 A5611C2C9F419D9F");
 
-  test_hash(&nettle_md5, 80,
+  test_hash(&nettle_md5,
 	    "1234567890123456789012345678901234567890"
 	    "1234567890123456789012345678901234567890",
-	    H("57EDF4A22BE3C955 AC49DA2E2107B67A"));
+	    "57EDF4A22BE3C955 AC49DA2E2107B67A");
 
   /* Additional test vector, from Daniel Kahn Gillmor */
-  test_hash(&nettle_md5, LDATA("38"),
-	    H("a5771bce93e200c3 6f7cd9dfd0e5deaa"));
+  test_hash(&nettle_md5, "38",
+	    "a5771bce93e200c3 6f7cd9dfd0e5deaa");
 
   /* Collisions, reported by Xiaoyun Wang1, Dengguo Feng2, Xuejia
      Lai3, Hongbo Yu1, http://eprint.iacr.org/2004/199. */
@@ -82,17 +82,17 @@ test_main(void)
   
 #define H1 "79054025 255fb1a2 6e4bc422 aef54eb4"
   
-  test_hash(&nettle_md5,
-	    HL(M0 N0), H(H0));
+  test_hash_hex(&nettle_md5,
+	    M0 N0, H0);
 
-  test_hash(&nettle_md5,
-	    HL(M1 N1), H(H0));
+  test_hash_hex(&nettle_md5,
+	    M1 N1, H0);
 
-  test_hash(&nettle_md5,
-	    HL(M0 N2), H(H1));
+  test_hash_hex(&nettle_md5,
+	    M0 N2, H1);
 
-  test_hash(&nettle_md5,
-	    HL(M1 N3), H(H1));
+  test_hash_hex(&nettle_md5,
+	    M1 N3, H1);
 
   SUCCESS();
 }
diff --git a/testsuite/memxor-test.c b/testsuite/memxor-test.c
index 8c191f3..8c4388d 100644
--- a/testsuite/memxor-test.c
+++ b/testsuite/memxor-test.c
@@ -145,5 +145,9 @@ test_main(void)
 	    test_memxor3 (a, b, c, size[i], align_dst, align_a, align_b);
 	}
 
+  free((void *)c);
+  free((void *)b);
+  free((void *)a);
+
   SUCCESS();
 }
diff --git a/testsuite/random-prime-test.c b/testsuite/random-prime-test.c
index 6fdb449..ac37576 100644
--- a/testsuite/random-prime-test.c
+++ b/testsuite/random-prime-test.c
@@ -23,6 +23,7 @@ test_main(void)
       ASSERT (mpz_sizeinbase (p, 2) == bits);
       ASSERT (mpz_probab_prime_p(p, 25));
     }
+  mpz_clear(p);
 
   SUCCESS();
 }
diff --git a/testsuite/ripemd160-test.c b/testsuite/ripemd160-test.c
index 1237b70..4d30612 100644
--- a/testsuite/ripemd160-test.c
+++ b/testsuite/ripemd160-test.c
@@ -4,34 +4,34 @@
 int
 test_main(void)
 {
-  test_hash(&nettle_ripemd160, 0, "",
-      H("9c1185a5c5e9fc54612808977ee8f548b2258d31"));
+  test_hash(&nettle_ripemd160, "",
+      "9c1185a5c5e9fc54612808977ee8f548b2258d31");
 
-  test_hash(&nettle_ripemd160, 1, "a",
-      H("0bdc9d2d256b3ee9daae347be6f4dc835a467ffe"));
+  test_hash(&nettle_ripemd160, "a",
+      "0bdc9d2d256b3ee9daae347be6f4dc835a467ffe");
 
-  test_hash(&nettle_ripemd160, 3, "abc",
-      H("8eb208f7e05d987a9b044a8e98c6b087f15a0bfc"));
+  test_hash(&nettle_ripemd160, "abc",
+      "8eb208f7e05d987a9b044a8e98c6b087f15a0bfc");
 
-  test_hash(&nettle_ripemd160, 26, "abcdefghijklmnopqrstuvwxyz",
-      H("f71c27109c692c1b56bbdceb5b9d2865b3708dbc"));
+  test_hash(&nettle_ripemd160, "abcdefghijklmnopqrstuvwxyz",
+      "f71c27109c692c1b56bbdceb5b9d2865b3708dbc");
 
-  test_hash(&nettle_ripemd160, 14, "message digest",
-      H("5d0689ef49d2fae572b881b123a85ffa21595f36"));
+  test_hash(&nettle_ripemd160, "message digest",
+      "5d0689ef49d2fae572b881b123a85ffa21595f36");
 
-  test_hash(&nettle_ripemd160, 62,
+  test_hash(&nettle_ripemd160,
       "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
       "abcdefghijklmnopqrstuvwxyz0123456789",
-      H("b0e20b6e3116640286ed3a87a5713079b21f5189"));
+      "b0e20b6e3116640286ed3a87a5713079b21f5189");
 
-  test_hash(&nettle_ripemd160,  80,
+  test_hash(&nettle_ripemd160,
       "1234567890123456789012345678901234567890"
       "1234567890123456789012345678901234567890",
-      H("9b752e45573d4b39f4dbd3323cab82bf63326bfb"));
+      "9b752e45573d4b39f4dbd3323cab82bf63326bfb");
 
   /* Additional test vector, from Daniel Kahn Gillmor */
-  test_hash(&nettle_ripemd160, LDATA("38"),
-      H("6b2d075b1cd34cd1c3e43a995f110c55649dad0e"));
+  test_hash(&nettle_ripemd160, "38",
+      "6b2d075b1cd34cd1c3e43a995f110c55649dad0e");
 
   SUCCESS();
 }
diff --git a/testsuite/rsa2sexp-test.c b/testsuite/rsa2sexp-test.c
index 596a978..00cfb8d 100644
--- a/testsuite/rsa2sexp-test.c
+++ b/testsuite/rsa2sexp-test.c
@@ -57,7 +57,7 @@ test_main(void)
       print_hex(buffer.size, buffer.contents);  
     }
   
-  ASSERT(MEMEQH(buffer.size, buffer.contents,
+  ASSERT(memeq_hex(buffer.size, buffer.contents,
 		"2831313a707269766174652d6b657928"
 		"333a72736128313a6e36333a085c3408"
 		"989acae4faec3cbbad91c90d34c1d259"
@@ -91,7 +91,8 @@ test_main(void)
       printf("public:");
       print_hex(buffer.size, buffer.contents);  
     }
-  ASSERT(MEMEQH(buffer.size, buffer.contents,
+
+  ASSERT(memeq_hex(buffer.size, buffer.contents,
 		"2831303a7075626c69632d6b65792839"
 		"3a7273612d706b63733128313a6e3633"
 		"3a085c3408989acae4faec3cbbad91c9"
@@ -103,5 +104,7 @@ test_main(void)
   rsa_public_key_clear(&pub);
   rsa_private_key_clear(&priv);
   
+  nettle_buffer_clear(&buffer);
+
   SUCCESS();
 }
diff --git a/testsuite/salsa20-test.c b/testsuite/salsa20-test.c
index 7a246b9..af61dc9 100644
--- a/testsuite/salsa20-test.c
+++ b/testsuite/salsa20-test.c
@@ -13,18 +13,23 @@ memzero_p (const uint8_t *p, size_t n)
   return 1;
 }
 
-/* The ecrypt testcases encrypt 512 zero bytes (8 blocks), then give
-   the xor of all blocks, and the data for block 0 (0-43), 3,4
-   (192-319), 7 (448-511) */
+/* The ecrypt testcases encrypt 512 zero bytes (8 blocks, then give
+   the xor of all blocks, and the data for block 0 (0-43, 3,4
+   (192-319, 7 (448-511) */
 
 #define STREAM_LENGTH 512
 static void
-test_salsa20_stream(unsigned key_length,
-		    const uint8_t *key,
-		    const uint8_t *iv,
-		    const uint8_t *ciphertext,
-		    const uint8_t *xor_ref)
+test_salsa20_stream(const uint8_t *key_hex,
+		    const uint8_t *iv_hex,
+		    const uint8_t *ciphertext_hex,
+		    const uint8_t *xor_ref_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  const uint8_t *iv = decode_hex_dup(iv_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+  const uint8_t *xor_ref = decode_hex_dup(xor_ref_hex);
+
   struct salsa20_ctx ctx;
   uint8_t data[STREAM_LENGTH + 1];
   uint8_t stream[STREAM_LENGTH + 1];
@@ -111,16 +116,26 @@ test_salsa20_stream(unsigned key_length,
 	  FAIL();
 	}
     }
+
+  free((void *)xor_ref);
+  free((void *)ciphertext);
+  free((void *)iv);
+  free((void *)key);
 }
 
 static void
-test_salsa20(unsigned key_length,
-	     const uint8_t *key,
-	     const uint8_t *iv,
-	     unsigned length,
-	     const uint8_t *cleartext,
-	     const uint8_t *ciphertext)
+test_salsa20(const uint8_t *key_hex,
+	     const uint8_t *iv_hex,
+	     const uint8_t *cleartext_hex,
+	     const uint8_t *ciphertext_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  const uint8_t *iv = decode_hex_dup(iv_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+
   struct salsa20_ctx ctx;
   uint8_t *data = xalloc(length + 1);
 
@@ -163,6 +178,10 @@ test_salsa20(unsigned key_length,
     }
 
   free(data);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)iv);
+  free((void *)key);
 }
   
 int
@@ -170,42 +189,42 @@ test_main(void)
 {
   /* http://www.ecrypt.eu.org/stream/svn/viewcvs.cgi/ecrypt/trunk/submissions/salsa20/full/verified.test-vectors?logsort=rev&rev=210&view=markup */
 
-  test_salsa20(HL("80000000 00000000 00000000 00000000"),
-	       H("00000000 00000000"),
-	       HL("00000000 00000000"),
-	       H("4DFA5E48 1DA23EA0"));
-
-  test_salsa20(HL("00000000 00000000 00000000 00000000"),
-	       H("80000000 00000000"),
-	       HL("00000000 00000000"),
-	       H("B66C1E44 46DD9557"));
-
-  test_salsa20(HL("0053A6F94C9FF24598EB3E91E4378ADD"),
-	       H("0D74DB42A91077DE"),
-	       HL("00000000 00000000"),
-	       H("05E1E7BE B697D999"));
-
-  test_salsa20(HL("80000000 00000000 00000000 00000000"
-		  "00000000 00000000 00000000 00000000"),
-	       H("00000000 00000000"),
-	       HL("00000000 00000000"),
-	       H("E3BE8FDD 8BECA2E3"));
-
-  test_salsa20(HL("00000000 00000000 00000000 00000000"
-		  "00000000 00000000 00000000 00000000"),
-	       H("80000000 00000000"),
-	       HL("00000000 00000000"),
-	       H("2ABA3DC45B494700"));
-
-  test_salsa20(HL("0053A6F94C9FF24598EB3E91E4378ADD"
-		  "3083D6297CCF2275C81B6EC11467BA0D"),
-	       H("0D74DB42A91077DE"),
-	       HL("00000000 00000000"),
-	       H("F5FAD53F 79F9DF58"));
-
-  test_salsa20_stream(HL("80000000000000000000000000000000"),
-		      H("00000000 00000000"),
-		      H("4DFA5E481DA23EA09A31022050859936"
+  test_salsa20("80000000 00000000 00000000 00000000",
+	       "00000000 00000000",
+	       "00000000 00000000",
+	       "4DFA5E48 1DA23EA0");
+
+  test_salsa20("00000000 00000000 00000000 00000000",
+	       "80000000 00000000",
+	       "00000000 00000000",
+	       "B66C1E44 46DD9557");
+
+  test_salsa20("0053A6F94C9FF24598EB3E91E4378ADD",
+	       "0D74DB42A91077DE",
+	       "00000000 00000000",
+	       "05E1E7BE B697D999");
+
+  test_salsa20("80000000 00000000 00000000 00000000"
+		  "00000000 00000000 00000000 00000000",
+	       "00000000 00000000",
+	       "00000000 00000000",
+	       "E3BE8FDD 8BECA2E3");
+
+  test_salsa20("00000000 00000000 00000000 00000000"
+		  "00000000 00000000 00000000 00000000",
+	       "80000000 00000000",
+	       "00000000 00000000",
+	       "2ABA3DC45B494700");
+
+  test_salsa20("0053A6F94C9FF24598EB3E91E4378ADD"
+		  "3083D6297CCF2275C81B6EC11467BA0D",
+	       "0D74DB42A91077DE",
+	       "00000000 00000000",
+	       "F5FAD53F 79F9DF58");
+
+  test_salsa20_stream("80000000000000000000000000000000",
+		      "00000000 00000000",
+		      "4DFA5E481DA23EA09A31022050859936"
 			"DA52FCEE218005164F267CB65F5CFD7F"
 			"2B4F97E0FF16924A52DF269515110A07"
 			"F9E460BC65EF95DA58F740B7D1DBB0AA"
@@ -220,16 +239,16 @@ test_main(void)
 			"B375703739DACED4DD4059FD71C3C47F"
 			"C2F9939670FAD4A46066ADCC6A564578"
 			"3308B90FFB72BE04A6B147CBE38CC0C3"
-			"B9267C296A92A7C69873F9F263BE9703"),
-		      H("F7A274D268316790A67EC058F45C0F2A"
+			"B9267C296A92A7C69873F9F263BE9703",
+		      "F7A274D268316790A67EC058F45C0F2A"
 			"067A99FCDE6236C0CEF8E056349FE54C"
 			"5F13AC74D2539570FD34FEAB06C57205"
-			"3949B59585742181A5A760223AFA22D4"));
+			"3949B59585742181A5A760223AFA22D4");
 
-  test_salsa20_stream(HL("48494A4B4C4D4E4F5051525354555657"
-			 "58595A5B5C5D5E5F6061626364656667"),
-		      H("0000000000000000"),
-		      H("53AD3698A011F779AD71030F3EFBEBA0"
+  test_salsa20_stream("48494A4B4C4D4E4F5051525354555657"
+			 "58595A5B5C5D5E5F6061626364656667",
+		      "0000000000000000",
+		      "53AD3698A011F779AD71030F3EFBEBA0"
 			"A7EE3C55789681B1591EF33A7BE521ED"
 			"68FC36E58F53FFD6E1369B00E390E973"
 			"F656ACB097E0D603BE59A0B8F7975B98"
@@ -244,11 +263,11 @@ test_main(void)
 			"B505D41E2C207FA1C0A0E93413DDCFFC"
 			"9BECA8030AFFAC2466E56482DA0EF428"
 			"E63880B5021D3051F18679505A2B9D4F"
-			"9B2C5A2D271D276DE3F51DBEBA934436"),
-		      H("7849651A820B1CDFE36D5D6632716534"
+			"9B2C5A2D271D276DE3F51DBEBA934436",
+		      "7849651A820B1CDFE36D5D6632716534"
 			"E0635EDEFD538122D80870B60FB055DB"
 			"637C7CA2B78B116F83AFF46E40F8F71D"
-			"4CD6D2E1B750D5E011D1DF2E80F7210A"));
+			"4CD6D2E1B750D5E011D1DF2E80F7210A");
 
   SUCCESS();
 }
